Loading...
Searching...
No Matches
shiftgb.cc File Reference
`#include "kernel/mod2.h"`
`#include "polys/monomials/ring.h"`
`#include "kernel/polys.h"`
`#include "coeffs/numbers.h"`
`#include "kernel/ideals.h"`
`#include "polys/matpol.h"`
`#include "polys/kbuckets.h"`
`#include "kernel/GBEngine/kstd1.h"`
`#include "polys/sbuckets.h"`
`#include "polys/operations/p_Mult_q.h"`
`#include "kernel/GBEngine/kutil.h"`
`#include "kernel/structs.h"`
`#include "kernel/GBEngine/khstd.h"`
`#include "polys/weight.h"`
`#include "misc/intvec.h"`
`#include "kernel/GBEngine/kInline.h"`
`#include "kernel/combinatorics/stairc.h"`
`#include "kernel/GBEngine/shiftgb.h"`
`#include "polys/nc/sca.h"`
`#include "polys/shiftop.h"`

Go to the source code of this file.

## Functions

poly | p_LPCopyAndShiftLM (poly p, int sh, const ring r)
int | p_mLPmaxPossibleShift (poly p, const ring r)

## Function Documentation

## p_LPCopyAndShiftLM()

poly p_LPCopyAndShiftLM | ( | poly | p,
|  | int | sh,
|  | const ring | r )

Definition at line 35 of file shiftgb.cc.

{
if (sh == 0 || p == NULL) return p;
poly q = p_Head(p, r);
p_mLPshift(q, sh, r);
pNext(q) = pNext(p);
return q;
}
p
int p
Definition cfModGcd.cc:4086
pNext
#define pNext(p)
Definition monomials.h:36
NULL
#define NULL
Definition omList.c:12
p_Head
static poly p_Head(const poly p, const ring r)
copy the (leading) term of p
Definition p_polys.h:862
p_mLPshift
void p_mLPshift(poly m, int sh, const ring ri)
Definition shiftop.cc:362

## p_mLPmaxPossibleShift()

int p_mLPmaxPossibleShift | ( | poly | p,
|  | const ring | r )

Definition at line 45 of file shiftgb.cc.

{
int lastBlock = p_mLastVblock(p, r);
if (lastBlock == 0) return 0;
int uptodeg = r->N/r->isLPring;
return uptodeg - lastBlock;
}
p_mLastVblock
int p_mLastVblock(poly p, const ring ri)
Definition shiftop.cc:421